#include "global.h"


struct	s_chan	*chan_start = NULL;


void	add_chan(char *channame)
{
	struct	s_chan	*ch,
			*new = (struct s_chan *) malloc(sizeof(struct s_chan));

	if (chan_start == NULL) {
		chan_start = new;
	} else {

		for(ch = chan_start; ch->next != NULL; ch = ch->next) ;

		ch->next = new;							// add new entry to the chain
	}

	new->next	= NULL;							// this will be the tail of the chain
	new->isJoined   = FALSE;
	new->num_users	= 0;
	new->name	= (char *) malloc(strlen(channame));

	strcpy(new->name, channame);
}


struct	s_chan * get_chanindex(char *channame)
{
	struct	s_chan	*ch;

	for(ch = chan_start; ch != NULL; ch = ch->next) {
		if (!strcmp(channame, ch->name)) return ch;
	}

	return NULL;
}


void	del_chan(char *channame)
{
	struct	s_chan	*last, *ch;

	for(ch = chan_start; ch != NULL; ch = ch->next) {
		if (!strcmp(channame, ch->name)) {

			if (ch == chan_start)
				chan_start = ch->next;
			else
				last->next = ch->next;

			free(ch->name);						// we must free this too!

			free(ch);
		}

		last = ch;
	}


}


void	join_channels()
{
	struct	s_chan	*ch;

	for(ch = chan_start; ch != NULL; ch = ch->next) {

		if (ch->isJoined == FALSE) {
			Send(sock_irc,	"JOIN %s :%s\nMODE %s +tn\nMODE %s -x\nWHO %s\n",
					ch->name, "somekey", ch->name, botnick, ch->name);
#ifdef	DEBUG
			Send(sock_hub, "LOG Joined %s\n", ch->name);
#endif
		}
	}

}

void	kickban_user(char *channel, char *user)
{
	char	*c,
		*hostname = strchr(user, '@');

	for(c = user; *c != '!'; c ++) ;
	*c = 0;

	// A bot will not kick itself!

	if (get_protnickidx(user) != NULL) {

		if (conn_hub == FALSE) return;

		Send(sock_hub,  "LOG kickban_user(): I will not kickban %s !\n", user);
		return;
	}

	Send(sock_irc,  "MODE %s -o+b %s *!*%s\nKICK %s %s :Buddha forgive you\n",
			channel, user, hostname, channel, user);

	return;
}


void	op_user(char *channel, char *nickname)
{
	Send(sock_irc,  "MODE %s +o %s\n", channel, nickname);
}


void	reset_channel_info()
{
	return;
}
