#include "global.h"

char	bot_key[] = "fUSiy8kt1";

/*****************************************************************************************
	GENERAL HUB FUNCTIONS
*****************************************************************************************/

char	*hub_parse(char *str)
{
	char	*c = str;

	for(c = str; *c; c ++)
		if (*c == '\n') break;

	*c = 0;

	return c + 1;
}

/*****************************************************************************************
	FUNCTIONS WHICH INFORM THE HUB ABOUT THE BOT
*****************************************************************************************/

void	hub_sendversion()
{
	if (conn_hub == TRUE) Send(sock_hub, "VERSION %d\n", bot_version);

	return;
}


void	hub_sendonline()
{
	if (conn_hub == TRUE) Send(sock_hub, "ONLINE %s\n", botnick);

	return;
}

/*****************************************************************************************
	HUB COMMANDS
*****************************************************************************************/

void	hubcmd_addchan(void)
{
	add_chan(hub_arg[1]);

	Send(sock_hub, "LOG Added channel %s\n", hub_arg[1]);

	Send(sock_irc, "JOIN %s\n", hub_arg[1]);
}


void	hubcmd_addfriend(void)
{
	add_protnick(hub_arg[1]);
}


void	hubcmd_authsuccess(void)
{
	add_protnick(hub_arg[1]);

	Send(sock_irc, "NOTICE %s :Welcome to fltnet\n", hub_arg[1]);
}


void    hubcmd_delchan(void)
{
        del_chan(hub_arg[1]);

	Send(sock_hub, "LOG Deleted channel %s\n", hub_arg[1]);

        Send(sock_irc, "PART %s\n", hub_arg[1]);
}


void	hubcmd_kickban(void)
{
	kickban_user(hub_arg[1], hub_arg[2]);

}


void	hubcmd_login(void)
{
	Send(sock_hub, bot_key);
}


void	hubcmd_needinvite(void)
{
	Send(sock_irc, "INVITE %s %s\n", hub_arg[1], hub_arg[2]);
}


void	hubcmd_needops(void)
{
	op_user(hub_arg[1], hub_arg[2]);
}


void	hubcmd_nickname(void)
{
	Send(sock_hub, botnick);
}

//	BOTUPGD <filesize>
//

void	hubcmd_upgrade(void)
{
	FILE	*out;
	char	curdir[1024], *tardata;
	char	tmp_binary[] = "/tmp/fltXXXXXX";

	int	len, botupg_filesize = atol(hub_arg[1]);

	if ((tardata = (char *) malloc(botupg_filesize)) == NULL) {
		Send(sock_hub, "LOG Not enough memory for upgrade!\n");
		return;
	}

	if ((out = fopen("/tmp/fltnet.tgz", "wb")) == NULL) {
		Send(sock_hub, "LOG Unable to open output file for upgrade package!\n");
		return;
	}

	Send(sock_hub, "SENDUPGD foo1\n");

	// wait for the hub to send the whole package

	tardata = receive_file("/tmp/fltnet.tgz", botupg_filesize);

/*	if((len = recv(sock_hub, tardata, botupg_filesize, 0)) >= botupg_filesize) {

		fwrite(tardata, botupg_filesize, 1, out);
		fclose(out);

		Send(sock_hub, "LOG Upgrade package received!\n");

	} else {
		Send(sock_hub, "LOG Error receiving package (errno=%d): %s\n", errno, strerror(errno));
	}	*/

	mktemp(&tmp_binary);
	Send(sock_hub, "LOG temp: %s\n", tmp_binary);
//	getcwd(curdir);

	if (!hub_exec("Uncompressing",	"tar -C /tmp -zxf /tmp/fltnet.tgz")) return;

	chdir("/tmp/fltnet");
	if (!hub_exec("Compiling",	"make")) return;

	if (!hub_exec("Trace deleting",	"cp fltnet %s", tmp_binary)) return;

	chdir("/tmp");	
//	chdir(curdir);

	if (!hub_exec("Trace deleting",	"rm -rf /tmp/fltnet")) return;

	Send(sock_hub, "LOG Restarting...\n");

	execl(tmp_binary, tmp_binary, NULL);
}


int	hub_exec(char *phase, char *cmd, ...)
{
	char	cmdstr[256];
	va_list	args;

	va_start(args, cmd);
	vsprintf(cmdstr, cmd, args);
	va_end(args);

	strcat(cmdstr, " >/dev/null 2>&1");

	if (system(cmdstr)) {
		Send(sock_hub, "LOG %s phase failed!\n", phase);
		return 0;
	}

	return 1;
}
